import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import { showPopup, hidePopup, hasClass, contains, closest, createElement, getElement, removeChild } from '@mescius/wijmo';
import { ListBox } from '@mescius/wijmo.input';
import { FlexGrid } from '@mescius/wijmo.grid';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
// generate some random data
var data = [], countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = ['Widget', 'Sprocket', 'Gadget', 'Doohickey'], colors = ['Black', 'White', 'Red', 'Green', 'Blue'], dt = new Date();
for (var i = 0; i < 100; i++) {
var date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60), countryId = Math.floor(Math.random() * countries.length), productId = Math.floor(Math.random() * products.length), colorId = Math.floor(Math.random() * colors.length);
var item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
countryId: countryId,
productId: productId,
colorId: colorId,
amount1: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
amount3: Math.random() * 10000 - 5000,
amount4: Math.random() * 10000 - 5000,
amount5: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0
};
data.push(item);
}
// create the grid
var theGrid = new FlexGrid('#theGrid', {
itemsSource: data,
formatItem: function (s, e) {
if (e.panel == s.topLeftCells) {
e.cell.innerHTML = '<span class="column-picker-icon glyphicon glyphicon-cog"></span>';
}
}
});
// create the column picker
var theColumnPicker = new ListBox('#theColumnPicker', {
itemsSource: theGrid.columns,
checkedMemberPath: 'visible',
displayMemberPath: 'header',
lostFocus: function () {
hidePopup(theColumnPicker.hostElement);
}
});
// show the column picker when the user clicks the top-left cell
var ref = theGrid.hostElement.querySelector('.wj-topleft');
ref.addEventListener('mousedown', function (e) {
if (hasClass(e.target, 'column-picker-icon')) {
let host = theColumnPicker.hostElement;
if (!host.offsetHeight) {
showPopup(host, ref, false, true, false);
theColumnPicker.focus();
}
else {
hidePopup(host, true, true);
theGrid.focus();
}
e.preventDefault();
}
});
// work around Safari/IOS bug (TFS 321525, 361500, 402670)
// https://developer.mozilla.org/en-US/docs/Web/Events/click#Safari_Mobile
window.addEventListener('touchstart', (e) => {
let host = theColumnPicker.hostElement;
if (!contains(host, e.target) && !closest(e.target, '.wj-flexgrid')) {
hidePopup(host, true, true);
}
});
// save/restore layout buttons
document.getElementById('btnSave').addEventListener('click', function () {
localStorage.setItem('myLayout', theGrid.columnLayout);
});
document.getElementById('btnRestore').addEventListener('click', function () {
var layout = localStorage.getItem('myLayout');
if (layout) {
theGrid.columnLayout = layout;
}
});
// column picker's drag-and-drop
var isDragEnabled = false;
var dragSrc = null;
var dragDst = null;
var dragCheckbox = document.getElementById('enableDrag');
dragCheckbox.addEventListener('click', function (e) {
var element = e.target;
isDragEnabled = element.checked;
var host = theColumnPicker.hostElement;
var items = host.getElementsByClassName('wj-listbox-item');
for (var i = 0; i < items.length; i++) {
enableDragItem(items[i], isDragEnabled);
}
});
theColumnPicker.formatItem.addHandler(function (s, e) {
enableDragItem(e.item, isDragEnabled);
});
var theColumnPickerHost = theColumnPicker.hostElement;
theColumnPickerHost.addEventListener('dragstart', handleDragStart);
theColumnPickerHost.addEventListener('dragover', handleDragOver);
theColumnPickerHost.addEventListener('drop', handleDrop);
theColumnPickerHost.addEventListener('dragend', handleDragEnd);
function enableDragItem(item, enabled) {
item.setAttribute('draggable', enabled);
}
function handleDragStart(e) {
dragSrc = closest(e.target, '.wj-listbox-item');
if (dragSrc) {
e.dataTransfer.setData('text', dragSrc.innerHTML);
e.dataTransfer.effectAllowed = 'move';
}
}
function handleDragOver(e) {
var dragOver = closest(e.target, '.wj-listbox-item');
if (dragDst && dragDst !== dragOver) {
removeDropMarker();
}
if (dragOver && dragOver !== dragSrc) {
e.preventDefault();
e.dataTransfer.dropEffect = 'move';
dragDst = dragOver;
var src = getElementIndex(dragSrc);
var dst = getElementIndex(dragDst);
removeDropMarker();
addDropMarker(dst > src);
}
else {
dragDst = null;
}
}
function handleDrop(e) {
if (dragSrc && dragDst) {
e.preventDefault();
var src = getElementIndex(dragSrc);
var dst = getElementIndex(dragDst);
theGrid.columns.moveElement(src, dst);
}
}
function handleDragEnd() {
dragSrc = null;
dragDst = null;
removeDropMarker();
}
function getElementIndex(element) {
var parent = element.parentElement;
var siblings = Array.prototype.slice.call(parent.children);
return siblings.indexOf(element);
}
function removeDropMarker() {
removeChild(getElement('.drop-marker'));
}
function addDropMarker(isAfterPos) {
const itemsGap = 10;
const width = 6;
var margin = itemsGap / width;
var height = dragDst.clientHeight;
var topPos = dragDst.offsetTop;
var leftPos = isAfterPos
? (dragDst.offsetLeft + dragDst.clientWidth + margin)
: (dragDst.offsetLeft - itemsGap + margin);
var html = `<div class="drop-marker"
style="top:${topPos}px;left:${leftPos}px;height:${height}px;width:${width}px">
 
</div>`;
createElement(html, theColumnPicker.hostElement);
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Picker</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="theGrid"></div>
<div style="display:none">
<div id="theColumnPicker" class="column-picker"></div>
</div>
<div class="checkbox">
<label>
<input id="enableDrag" type="checkbox"> Enable drag-and-drop
</label>
</div>
<p>
You can use the grid's <b>columnLayout</b> property to allow users
to save and restore column layouts. Click the buttons below
to see how this works:</p>
<button id="btnSave" class="btn btn-default">
Save Layout
</button>
<button id="btnRestore" class="btn btn-default">
Restore Layout
</button>
</div>
</body>
</html>
.wj-flexgrid {
max-height: 300px;
margin: 10px 0;
}
.column-picker-icon {
cursor: pointer;
color: #FF8754;
margin: 3px;
}
.wj-listbox.column-picker {
display: grid;
grid-template-columns: repeat(4, 1fr);
grid-gap: 0 10px;
columns: 4; /* IE fallback */
padding: 12px;
margin-left: 12px;
margin-top: 26px;
box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23);
}
.wj-listbox .wj-listbox-item > label {
display: block;
margin: 0 0 3px 0;
}
.wj-listbox .wj-listbox-item.wj-state-selected
{
background: transparent;
color: inherit;
}
.wj-listbox .wj-listbox-item:hover {
background: rgba(0,0,0,.05);
}
.wj-listbox .drop-marker {
position: absolute;
background: #0085c7;
opacity: 0.5;
pointer-events: none;
z-index: 1000;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import {
showPopup,
hidePopup,
hasClass,
contains,
closest,
createElement,
getElement,
removeChild,
} from '@mescius/wijmo';
import { ListBox } from '@mescius/wijmo.input';
import { FlexGrid, FormatItemEventArgs } from '@mescius/wijmo.grid';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
//
@Component({
standalone: true,
imports: [WjGridModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: any[];
// references FlexGrid named 'flex' in the view
@ViewChild('flex', { static: true }) flex: FlexGrid;
@ViewChild('columnPicker', { static: true }) columnPicker: ListBox;
private _isDragEnabled: boolean = false;
private _dragSrc: HTMLElement = null;
private _dragDst: HTMLElement = null;
// DataSvc will be passed by derived classes
constructor() {
this.data = this._getData();
}
ngOnInit() {
if (this.flex) {
this.flex.formatItem.addHandler((s: FlexGrid, e: FormatItemEventArgs) => {
if (e.panel == s.topLeftCells) {
e.cell.innerHTML = '<span class="column-picker-icon glyphicon glyphicon-cog"></span>';
}
});
// show the column picker when the user clicks the top-left cell
let ref = this.flex.hostElement.querySelector('.wj-topleft');
ref.addEventListener('mousedown', (e) => {
if (hasClass(<Element>e.target, 'column-picker-icon')) {
let host = this.columnPicker.hostElement;
if (!host.offsetHeight) {
showPopup(host, ref, false, true, false);
this.columnPicker.focus();
} else {
hidePopup(host, true, true);
this.flex.focus();
}
e.preventDefault();
}
});
// work around Safari/IOS bug (TFS 321525, 361500, 402670)
// https://developer.mozilla.org/en-US/docs/Web/Events/click#Safari_Mobile
window.addEventListener('touchstart', (e) => {
let host = this.columnPicker.hostElement;
if (!contains(host, e.target) && !closest(e.target, '.wj-flexgrid')) {
hidePopup(host, true, true);
}
});
}
}
ngAfterViewInit() {
if (this.flex) {
this.columnPicker.itemsSource = this.flex.columns;
this.columnPicker.checkedMemberPath = 'visible';
this.columnPicker.displayMemberPath = 'header';
this.columnPicker.lostFocus.addHandler(() => {
hidePopup(this.columnPicker.hostElement);
});
this.columnPicker.formatItem.addHandler((s, e) => {
this._enableDragItem(e.item, this._isDragEnabled);
});
}
}
saveLayout() {
localStorage.setItem('myLayout', this.flex.columnLayout);
}
loadLayout() {
let layout = localStorage.getItem('myLayout');
if (layout) {
this.flex.columnLayout = layout;
}
}
handleDragStart(e: DragEvent) {
this._dragSrc = <HTMLElement>closest(e.target, '.wj-listbox-item');
if (this._dragSrc) {
e.dataTransfer.setData('text', this._dragSrc.innerHTML);
e.dataTransfer.effectAllowed = 'move';
}
}
handleDragOver(e: DragEvent) {
const dragOver = <HTMLElement>closest(e.target, '.wj-listbox-item');
if (this._dragDst && this._dragDst !== dragOver) {
this._removeDropMarker();
}
if (dragOver && dragOver !== this._dragSrc) {
e.preventDefault();
e.dataTransfer.dropEffect = 'move';
this._dragDst = dragOver;
const src = this._getElementIndex(this._dragSrc);
const dst = this._getElementIndex(this._dragDst);
this._removeDropMarker();
this._addDropMarker(dst > src);
} else {
this._dragDst = null;
}
}
handleDrop(e: DragEvent) {
if (this._dragSrc && this._dragDst) {
e.preventDefault();
const src = this._getElementIndex(this._dragSrc);
const dst = this._getElementIndex(this._dragDst);
this.flex.columns.moveElement(src, dst);
}
}
handleDragEnd(e: DragEvent) {
this._dragSrc = null;
this._dragDst = null;
this._removeDropMarker();
}
enableDrag(e: Event) {
const element = <HTMLInputElement>e.target;
this._isDragEnabled = element.checked;
const host = this.columnPicker.hostElement;
const items = host.getElementsByClassName('wj-listbox-item');
for (let i = 0; i < items.length; i++) {
this._enableDragItem(items[i], this._isDragEnabled);
}
}
private _enableDragItem(item: Element, enabled: boolean) {
item.setAttribute('draggable', enabled.toString());
}
private _getElementIndex(element: Element): number {
const parent = element.parentElement;
const siblings = Array.prototype.slice.call(parent.children);
return siblings.indexOf(element);
}
private _removeDropMarker() {
removeChild(getElement('.drop-marker'));
}
private _addDropMarker(isAfterPos: boolean) {
const itemsGap = 10;
const width = 6;
const margin = itemsGap / width;
const height = this._dragDst.clientHeight;
const topPos = this._dragDst.offsetTop;
const leftPos = isAfterPos
? this._dragDst.offsetLeft + this._dragDst.clientWidth + margin
: this._dragDst.offsetLeft - itemsGap + margin;
const css = `top:${topPos}px;left:${leftPos}px;height:${height}px;width:${width}px`;
const html = `<div class="drop-marker" style="${css}"> </div>`;
createElement(html, this.columnPicker.hostElement);
}
private _getData() {
// generate some random data
let data = [],
countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'],
products = ['Widget', 'Sprocket', 'Gadget', 'Doohickey'],
colors = ['Black', 'White', 'Red', 'Green', 'Blue'],
dt = new Date();
for (let i = 0; i < 100; i++) {
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
countryId: countryId,
productId: productId,
colorId: colorId,
amount1: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
amount3: Math.random() * 10000 - 5000,
amount4: Math.random() * 10000 - 5000,
amount5: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0,
};
data.push(item);
}
return data;
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Picker</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<wj-flex-grid #flex
[(itemsSource)]="data">
</wj-flex-grid>
<div style="display:none">
<wj-list-box #columnPicker class="column-picker"
(dragstart)="handleDragStart($event)"
(dragover)="handleDragOver($event)"
(drop)="handleDrop($event)"
(dragend)="handleDragEnd($event)">
</wj-list-box>
</div>
<div class="checkbox">
<label>
<input (click)="enableDrag($event)" type="checkbox"> Enable drag-and-drop
</label>
</div>
<p>
You can use the grid's <b>columnLayout</b> property to allow users
to save and restore column layouts. Click the buttons below
to see how this works:</p>
<button (click)="saveLayout()" class="btn btn-default">Save Layout</button>
<button (click)="loadLayout()" class="btn btn-default">Restore Layout</button>
</div>
.wj-flexgrid {
max-height: 300px;
margin: 10px 0;
}
.column-picker-icon {
cursor: pointer;
color: #FF8754;
margin: 3px;
}
.wj-listbox.column-picker {
display: grid;
grid-template-columns: repeat(4, 1fr);
grid-gap: 0 10px;
columns: 4; /* IE fallback */
padding: 12px;
margin-left: 12px;
margin-top: 26px;
box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23);
}
.wj-listbox .wj-listbox-item > label {
display: block;
margin: 0 0 3px 0;
}
.wj-listbox .wj-listbox-item.wj-state-selected
{
background: transparent;
color: inherit;
}
.wj-listbox .wj-listbox-item:hover {
background: rgba(0,0,0,.05);
}
.wj-listbox .drop-marker {
position: absolute;
background: #0085c7;
opacity: 0.5;
pointer-events: none;
z-index: 1000;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import { showPopup, hidePopup, hasClass, contains, closest, createElement, getElement, removeChild } from '@mescius/wijmo';
import { ListBox } from '@mescius/wijmo.react.input';
import { FlexGrid } from '@mescius/wijmo.react.grid';
import './app.css';
import { data } from './data';
function App() {
const [isDragEnabled, setIsDragEnabled] = useState(false);
const flexRef = useRef(null);
const columnPicker = useRef(null);
const dragSrc = useRef(null);
const dragDst = useRef(null);
useEffect(() => {
if (columnPicker.current) {
columnPicker.current.formatItem.addHandler((s, e) => {
handleEnableDragItem(e.item, isDragEnabled);
});
}
}, [isDragEnabled]);
const initializedGrid = useEvent((flex) => {
flexRef.current = flex;
flex.formatItem.addHandler((s, e) => {
if (e.panel == s.topLeftCells) {
e.cell.innerHTML = '<span class="column-picker-icon glyphicon glyphicon-cog"></span>';
}
});
// show the column picker when the user clicks the top-left cell
let ref = flex.hostElement.querySelector(".wj-topleft");
ref.addEventListener("mousedown", (e) => {
if (hasClass(e.target, "column-picker-icon")) {
let host = columnPicker.current.hostElement;
if (!host.offsetHeight) {
showPopup(host, ref, false, true, false);
columnPicker.current.focus();
}
else {
hidePopup(host, true, true);
flex.focus();
}
columnPicker.current.focus();
e.preventDefault();
}
});
// work around Safari/IOS bug (TFS 321525, 361500, 402670)
// https://developer.mozilla.org/en-US/docs/Web/Events/click#Safari_Mobile
window.addEventListener('touchstart', (e) => {
let host = columnPicker.current.hostElement;
if (!contains(host, e.target) && !closest(e.target, '.wj-flexgrid')) {
hidePopup(host, true, true);
}
});
});
const initializedPicker = useEvent((picker) => {
const host = picker.hostElement;
host.addEventListener('dragstart', handleDragStart);
host.addEventListener('dragover', handleDragOver);
host.addEventListener('drop', handleDrop);
host.addEventListener('dragend', handleDragEnd);
columnPicker.current = picker;
columnPicker.current.itemsSource = flexRef.current.columns;
columnPicker.current.checkedMemberPath = 'visible';
columnPicker.current.displayMemberPath = 'header';
columnPicker.current.lostFocus.addHandler(() => {
hidePopup(columnPicker.current.hostElement);
});
columnPicker.current.formatItem.addHandler((s, e) => {
handleEnableDragItem(e.item, isDragEnabled);
});
});
const hanndleSaveLayoutClick = () => {
localStorage.setItem("myLayout", flexRef.current.columnLayout);
};
const handleLoadLayoutClick = () => {
let layout = localStorage.getItem("myLayout");
if (layout) {
flexRef.current.columnLayout = layout;
}
};
const handleDragStart = (e) => {
dragSrc.current = closest(e.target, '.wj-listbox-item');
if (dragSrc.current && e.dataTransfer) {
e.dataTransfer.setData('text', dragSrc.current.innerHTML);
e.dataTransfer.effectAllowed = 'move';
}
};
const handleDragOver = (e) => {
const dragOver = closest(e.target, '.wj-listbox-item');
if (dragDst.current && dragDst.current !== dragOver) {
removeDropMarker();
}
if (dragOver && dragOver !== dragSrc.current) {
e.preventDefault();
if (dragSrc.current && e.dataTransfer) {
e.dataTransfer.dropEffect = 'move';
dragDst.current = dragOver;
const src = getElementIndex(dragSrc.current);
const dst = getElementIndex(dragDst.current);
removeDropMarker();
addDropMarker(dst > src);
}
}
else {
dragDst.current = null;
}
};
const handleDrop = (e) => {
if (dragSrc.current && dragDst.current) {
e.preventDefault();
const src = getElementIndex(dragSrc.current);
const dst = getElementIndex(dragDst.current);
flexRef.current.columns.moveElement(src, dst);
}
};
const handleDragEnd = () => {
dragSrc.current = null;
dragDst.current = null;
removeDropMarker();
};
const handleEnableDrag = (e) => {
const element = e.target;
setIsDragEnabled(element.checked);
};
const handleEnableDragItem = (item, enabled) => {
item.setAttribute('draggable', enabled.toString());
};
const getElementIndex = (element) => {
const parent = element.parentElement;
const siblings = Array.prototype.slice.call(parent ? parent.children : []);
return siblings.indexOf(element);
};
const removeDropMarker = () => {
removeChild(getElement('.drop-marker'));
};
const addDropMarker = (isAfterPos) => {
if (dragDst.current) {
const itemsGap = 10;
const width = 6;
const margin = itemsGap / width;
const height = dragDst.current.clientHeight;
const topPos = dragDst.current.offsetTop;
const leftPos = isAfterPos
? (dragDst.current.offsetLeft + dragDst.current.clientWidth + margin)
: (dragDst.current.offsetLeft - itemsGap + margin);
const css = `top:${topPos}px;left:${leftPos}px;height:${height}px;width:${width}px`;
const html = `<div class="drop-marker" style="${css}"> </div>`;
createElement(html, columnPicker.current.hostElement);
}
};
return (<div>
<main className="container-fluid">
<FlexGrid initialized={initializedGrid} itemsSource={data}/>
<div className="column-picker-div">
<ListBox className="column-picker" initialized={initializedPicker}/>
</div>
<div className="checkbox">
<label>
<input onClick={handleEnableDrag} type="checkbox"/> Enable drag-and-drop
</label>
</div>
<p>
You can use the grid's
<b> columnLayout </b> property to allow users
to save and restore column layouts. Click the buttons below
to see how this works:
</p>
<button className="btn btn-default" onClick={hanndleSaveLayoutClick}>Save Layout</button>
<button className="btn btn-default" onClick={handleLoadLayoutClick}>Restore Layout</button>
</main>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Column Picker</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
max-height: 300px;
margin: 10px 0;
}
.column-picker-icon {
cursor: pointer;
color: #FF8754;
margin: 3px;
}
.column-picker-div {
display: none;
}
.wj-listbox.column-picker {
display: grid;
grid-template-columns: repeat(4, 1fr);
grid-gap: 0 10px;
columns: 4;
/* IE fallback */
padding: 12px;
margin-left: 12px;
margin-top: 26px;
box-shadow: 0 10px 20px rgba(0, 0, 0, 0.19), 0 6px 6px rgba(0, 0, 0, 0.23);
}
.wj-listbox .wj-listbox-item>label {
margin: 0 0 3px 0;
}
.wj-listbox .wj-listbox-item.wj-state-selected {
background: transparent;
color: inherit;
}
.wj-listbox .wj-listbox-item:hover {
background: rgba(0, 0, 0, .05);
}
.wj-listbox .drop-marker {
position: absolute;
background: #0085c7;
opacity: 0.5;
pointer-events: none;
z-index: 1000;
}
function getData() {
let data = [], countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], products = ['Widget', 'Sprocket', 'Gadget', 'Doohickey'], colors = ['Black', 'White', 'Red', 'Green', 'Blue'], dt = new Date();
for (let i = 0; i < 100; i++) {
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60), countryId = Math.floor(Math.random() * countries.length), productId = Math.floor(Math.random() * products.length), colorId = Math.floor(Math.random() * colors.length);
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
countryId: countryId,
productId: productId,
colorId: colorId,
amount1: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
amount3: Math.random() * 10000 - 5000,
amount4: Math.random() * 10000 - 5000,
amount5: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0
};
data.push(item);
}
return data;
}
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<div class="container-fluid">
<wj-flex-grid :itemsSource="data" :initialized="initializedGrid"></wj-flex-grid>
<div style="display:none">
<wj-list-box class="column-picker" :initialized="initializedPicker"></wj-list-box>
</div>
<div class="checkbox">
<label>
<input v-on:click="enableDrag" type="checkbox"> Enable drag-and-drop
</label>
</div>
<p>
You can use the grid's
<b>columnLayout</b> property to allow users
to save and restore column layouts. Click the buttons below
to see how this works:
</p>
<button v-on:click="saveLayout" class="btn btn-default">Save Layout</button>
<button v-on:click="loadLayout" class="btn btn-default">Restore Layout</button>
</div>
</template>
<script>
import "@grapecity/wijmo.styles/wijmo.css";
import "bootstrap.css";
import Vue from "vue";
import "@grapecity/wijmo.vue2.grid";
import "@grapecity/wijmo.vue2.input";
import { showPopup, hidePopup, hasClass, contains, closest, createElement, getElement, removeChild } from "@grapecity/wijmo";
import { getData } from "./data";
new Vue({
el: "#app",
data: function() {
return {
data: getData(),
isDragEnabled: false,
dragSrc: null,
dragDst: null
};
},
methods: {
saveLayout() {
localStorage.setItem("myLayout", this.flex.columnLayout);
},
loadLayout() {
let layout = localStorage.getItem("myLayout");
if (layout) {
this.flex.columnLayout = layout;
}
},
initializedPicker(picker) {
this.columnPicker = picker;
},
initializedGrid(ctl) {
this.flex = ctl;
this.flex.formatItem.addHandler((s, e) => {
if (e.panel == s.topLeftCells) {
e.cell.innerHTML =
'<span class="column-picker-icon glyphicon glyphicon-cog"></span>';
}
});
// show the column picker when the user clicks the top-left cell
let ref = this.flex.hostElement.querySelector(".wj-topleft");
ref.addEventListener("mousedown", e => {
if (hasClass(e.target, "column-picker-icon")) {
let host = this.columnPicker.hostElement;
if (!host.offsetHeight) {
showPopup(host, ref, false, true, false);
this.columnPicker.focus();
} else {
hidePopup(host, true, true);
this.flex.focus();
}
e.preventDefault();
}
});
// work around Safari/IOS bug (TFS 321525, 361500, 402670)
// https://developer.mozilla.org/en-US/docs/Web/Events/click#Safari_Mobile
window.addEventListener('touchstart', (e) => {
let host = this.columnPicker.hostElement;
if (!contains(host, e.target) && !closest(e.target, '.wj-flexgrid')) {
hidePopup(host, true, true);
}
});
},
handleDragStart(e) {
this.dragSrc = closest(e.target, '.wj-listbox-item');
if (this.dragSrc) {
e.dataTransfer.setData('text', this.dragSrc.innerHTML);
e.dataTransfer.effectAllowed = 'move';
}
},
handleDragOver(e) {
const dragOver = closest(e.target, '.wj-listbox-item');
if (this.dragDst && this.dragDst !== dragOver) {
this._removeDropMarker();
}
if (dragOver && dragOver !== this.dragSrc) {
e.preventDefault();
e.dataTransfer.dropEffect = 'move';
this.dragDst = dragOver;
const src = this._getElementIndex(this.dragSrc);
const dst = this._getElementIndex(this.dragDst);
this._removeDropMarker();
this._addDropMarker(dst > src);
} else {
this.dragDst = null;
}
},
handleDrop(e) {
if (this.dragSrc && this.dragDst) {
e.preventDefault();
const src = this._getElementIndex(this.dragSrc);
const dst = this._getElementIndex(this.dragDst);
this.flex.columns.moveElement(src, dst);
}
},
handleDragEnd(e) {
this.dragSrc = null;
this.dragDst = null;
this._removeDropMarker();
},
enableDrag(e) {
const element = e.target;
this.isDragEnabled = element.checked;
const host = this.columnPicker.hostElement;
const items = host.getElementsByClassName('wj-listbox-item');
for (let i = 0; i < items.length; i++) {
this._enableDragItem(items[i], this.isDragEnabled);
}
},
_enableDragItem(item, enabled) {
item.setAttribute('draggable', enabled.toString());
},
_getElementIndex(element) {
const parent = element.parentElement;
const siblings = Array.prototype.slice.call(parent.children);
return siblings.indexOf(element);
},
_removeDropMarker() {
removeChild(getElement('.drop-marker'));
},
_addDropMarker(isAfterPos) {
const itemsGap = 10;
const width = 6;
const margin = itemsGap/width;
const height = this.dragDst.clientHeight;
const topPos = this.dragDst.offsetTop;
const leftPos = isAfterPos
? (this.dragDst.offsetLeft + this.dragDst.clientWidth + margin)
: (this.dragDst.offsetLeft - itemsGap + margin);
const css = `top:${topPos}px;left:${leftPos}px;height:${height}px;width:${width}px`;
const html = `<div class="drop-marker" style="${css}"> </div>`;
createElement(html, this.columnPicker.hostElement);
}
},
mounted: function() {
if (this.flex) {
this.columnPicker.itemsSource = this.flex.columns;
this.columnPicker.checkedMemberPath = 'visible';
this.columnPicker.displayMemberPath = 'header';
this.columnPicker.lostFocus.addHandler(() => {
hidePopup(this.columnPicker.hostElement);
});
this.columnPicker.formatItem.addHandler((s, e) => {
this._enableDragItem(e.item, this.isDragEnabled);
});
const host = this.columnPicker.hostElement;
host.addEventListener('dragstart', this.handleDragStart);
host.addEventListener('dragover', this.handleDragOver);
host.addEventListener('drop', this.handleDrop);
host.addEventListener('dragend', this.handleDragEnd);
}
}
});
</script>
<style>
.wj-flexgrid {
max-height: 300px;
margin: 10px 0;
}
.column-picker-icon {
cursor: pointer;
color: #FF8754;
margin: 3px;
}
.wj-listbox.column-picker {
display: grid;
grid-template-columns: repeat(4, 1fr);
grid-gap: 0 10px;
columns: 4; /* IE fallback */
padding: 12px;
margin-left: 12px;
margin-top: 26px;
box-shadow: 0 10px 20px rgba(0,0,0,0.19), 0 6px 6px rgba(0,0,0,0.23);
}
body .wj-listbox .wj-listbox-item > label {
display: block;
margin: 0 0 3px 0;
}
.wj-listbox .wj-listbox-item.wj-state-selected
{
background: transparent;
color: inherit;
}
.wj-listbox .wj-listbox-item:hover {
background: rgba(0,0,0,.05);
}
.wj-listbox .drop-marker {
position: absolute;
background: #0085c7;
opacity: 0.5;
pointer-events: none;
z-index: 1000;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Column Picker</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getData() {
let data = [],
countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'],
products = ['Widget', 'Sprocket', 'Gadget', 'Doohickey'],
colors = ['Black', 'White', 'Red', 'Green', 'Blue'],
dt = new Date();
for (let i = 0; i < 100; i++) {
let date = new Date(dt.getFullYear(), i % 12, 25, i % 24, i % 60, i % 60),
countryId = Math.floor(Math.random() * countries.length),
productId = Math.floor(Math.random() * products.length),
colorId = Math.floor(Math.random() * colors.length);
let item = {
id: i,
start: date,
end: date,
country: countries[countryId],
product: products[productId],
color: colors[colorId],
countryId: countryId,
productId: productId,
colorId: colorId,
amount1: Math.random() * 10000 - 5000,
amount2: Math.random() * 10000 - 5000,
amount3: Math.random() * 10000 - 5000,
amount4: Math.random() * 10000 - 5000,
amount5: Math.random() * 10000 - 5000,
discount: Math.random() / 4,
active: i % 4 == 0
};
data.push(item);
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@grapecity/wijmo': 'npm:@grapecity/wijmo/index.js',
'@grapecity/wijmo.input': 'npm:@grapecity/wijmo.input/index.js',
'@grapecity/wijmo.styles': 'npm:@grapecity/wijmo.styles',
'@grapecity/wijmo.cultures': 'npm:@grapecity/wijmo.cultures',
'@grapecity/wijmo.chart': 'npm:@grapecity/wijmo.chart/index.js',
'@grapecity/wijmo.chart.analytics': 'npm:@grapecity/wijmo.chart.analytics/index.js',
'@grapecity/wijmo.chart.animation': 'npm:@grapecity/wijmo.chart.animation/index.js',
'@grapecity/wijmo.chart.annotation': 'npm:@grapecity/wijmo.chart.annotation/index.js',
'@grapecity/wijmo.chart.finance': 'npm:@grapecity/wijmo.chart.finance/index.js',
'@grapecity/wijmo.chart.finance.analytics': 'npm:@grapecity/wijmo.chart.finance.analytics/index.js',
'@grapecity/wijmo.chart.hierarchical': 'npm:@grapecity/wijmo.chart.hierarchical/index.js',
'@grapecity/wijmo.chart.interaction': 'npm:@grapecity/wijmo.chart.interaction/index.js',
'@grapecity/wijmo.chart.radar': 'npm:@grapecity/wijmo.chart.radar/index.js',
'@grapecity/wijmo.chart.render': 'npm:@grapecity/wijmo.chart.render/index.js',
'@grapecity/wijmo.chart.webgl': 'npm:@grapecity/wijmo.chart.webgl/index.js',
'@grapecity/wijmo.chart.map': 'npm:@grapecity/wijmo.chart.map/index.js',
'@grapecity/wijmo.gauge': 'npm:@grapecity/wijmo.gauge/index.js',
'@grapecity/wijmo.grid': 'npm:@grapecity/wijmo.grid/index.js',
'@grapecity/wijmo.grid.detail': 'npm:@grapecity/wijmo.grid.detail/index.js',
'@grapecity/wijmo.grid.filter': 'npm:@grapecity/wijmo.grid.filter/index.js',
'@grapecity/wijmo.grid.search': 'npm:@grapecity/wijmo.grid.search/index.js',
'@grapecity/wijmo.grid.grouppanel': 'npm:@grapecity/wijmo.grid.grouppanel/index.js',
'@grapecity/wijmo.grid.multirow': 'npm:@grapecity/wijmo.grid.multirow/index.js',
'@grapecity/wijmo.grid.transposed': 'npm:@grapecity/wijmo.grid.transposed/index.js',
'@grapecity/wijmo.grid.transposedmultirow': 'npm:@grapecity/wijmo.grid.transposedmultirow/index.js',
'@grapecity/wijmo.grid.pdf': 'npm:@grapecity/wijmo.grid.pdf/index.js',
'@grapecity/wijmo.grid.sheet': 'npm:@grapecity/wijmo.grid.sheet/index.js',
'@grapecity/wijmo.grid.xlsx': 'npm:@grapecity/wijmo.grid.xlsx/index.js',
'@grapecity/wijmo.grid.selector': 'npm:@grapecity/wijmo.grid.selector/index.js',
'@grapecity/wijmo.grid.cellmaker': 'npm:@grapecity/wijmo.grid.cellmaker/index.js',
'@grapecity/wijmo.nav': 'npm:@grapecity/wijmo.nav/index.js',
'@grapecity/wijmo.odata': 'npm:@grapecity/wijmo.odata/index.js',
'@grapecity/wijmo.olap': 'npm:@grapecity/wijmo.olap/index.js',
'@grapecity/wijmo.rest': 'npm:@grapecity/wijmo.rest/index.js',
'@grapecity/wijmo.pdf': 'npm:@grapecity/wijmo.pdf/index.js',
'@grapecity/wijmo.pdf.security': 'npm:@grapecity/wijmo.pdf.security/index.js',
'@grapecity/wijmo.viewer': 'npm:@grapecity/wijmo.viewer/index.js',
'@grapecity/wijmo.xlsx': 'npm:@grapecity/wijmo.xlsx/index.js',
'@grapecity/wijmo.undo': 'npm:@grapecity/wijmo.undo/index.js',
'@grapecity/wijmo.interop.grid': 'npm:@grapecity/wijmo.interop.grid/index.js',
'@grapecity/wijmo.touch': 'npm:@grapecity/wijmo.touch/index.js',
'@grapecity/wijmo.cloud': 'npm:@grapecity/wijmo.cloud/index.js',
'@grapecity/wijmo.barcode': 'npm:@grapecity/wijmo.barcode/index.js',
'@grapecity/wijmo.barcode.common': 'npm:@grapecity/wijmo.barcode.common/index.js',
'@grapecity/wijmo.barcode.composite': 'npm:@grapecity/wijmo.barcode.composite/index.js',
'@grapecity/wijmo.barcode.specialized': 'npm:@grapecity/wijmo.barcode.specialized/index.js',
"@grapecity/wijmo.vue2.chart.analytics": "npm:@grapecity/wijmo.vue2.chart.analytics/index.js",
"@grapecity/wijmo.vue2.chart.animation": "npm:@grapecity/wijmo.vue2.chart.animation/index.js",
"@grapecity/wijmo.vue2.chart.annotation": "npm:@grapecity/wijmo.vue2.chart.annotation/index.js",
"@grapecity/wijmo.vue2.chart.finance.analytics": "npm:@grapecity/wijmo.vue2.chart.finance.analytics/index.js",
"@grapecity/wijmo.vue2.chart.finance": "npm:@grapecity/wijmo.vue2.chart.finance/index.js",
"@grapecity/wijmo.vue2.chart.hierarchical": "npm:@grapecity/wijmo.vue2.chart.hierarchical/index.js",
"@grapecity/wijmo.vue2.chart.interaction": "npm:@grapecity/wijmo.vue2.chart.interaction/index.js",
"@grapecity/wijmo.vue2.chart.radar": "npm:@grapecity/wijmo.vue2.chart.radar/index.js",
'@grapecity/wijmo.vue2.chart.map': 'npm:@grapecity/wijmo.vue2.chart.map/index.js',
"@grapecity/wijmo.vue2.chart": "npm:@grapecity/wijmo.vue2.chart/index.js",
"@grapecity/wijmo.vue2.core": "npm:@grapecity/wijmo.vue2.core/index.js",
"@grapecity/wijmo.vue2.gauge": "npm:@grapecity/wijmo.vue2.gauge/index.js",
"@grapecity/wijmo.vue2.grid.detail": "npm:@grapecity/wijmo.vue2.grid.detail/index.js",
"@grapecity/wijmo.vue2.grid.filter": "npm:@grapecity/wijmo.vue2.grid.filter/index.js",
"@grapecity/wijmo.vue2.grid.grouppanel": "npm:@grapecity/wijmo.vue2.grid.grouppanel/index.js",
'@grapecity/wijmo.vue2.grid.search': 'npm:@grapecity/wijmo.vue2.grid.search/index.js',
"@grapecity/wijmo.vue2.grid.multirow": "npm:@grapecity/wijmo.vue2.grid.multirow/index.js",
"@grapecity/wijmo.vue2.grid.sheet": "npm:@grapecity/wijmo.vue2.grid.sheet/index.js",
'@grapecity/wijmo.vue2.grid.transposed': 'npm:@grapecity/wijmo.vue2.grid.transposed/index.js',
'@grapecity/wijmo.vue2.grid.transposedmultirow': 'npm:@grapecity/wijmo.vue2.grid.transposedmultirow/index.js',
"@grapecity/wijmo.vue2.grid": "npm:@grapecity/wijmo.vue2.grid/index.js",
"@grapecity/wijmo.vue2.input": "npm:@grapecity/wijmo.vue2.input/index.js",
"@grapecity/wijmo.vue2.olap": "npm:@grapecity/wijmo.vue2.olap/index.js",
"@grapecity/wijmo.vue2.viewer": "npm:@grapecity/wijmo.vue2.viewer/index.js",
"@grapecity/wijmo.vue2.nav": "npm:@grapecity/wijmo.vue2.nav/index.js",
"@grapecity/wijmo.vue2.base": "npm:@grapecity/wijmo.vue2.base/index.js",
'@grapecity/wijmo.vue2.barcode.common': 'npm:@grapecity/wijmo.vue2.barcode.common/index.js',
'@grapecity/wijmo.vue2.barcode.composite': 'npm:@grapecity/wijmo.vue2.barcode.composite/index.js',
'@grapecity/wijmo.vue2.barcode.specialized': 'npm:@grapecity/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);